;Frekvence krystalu 4Mhz, t.j. 1 instrukce = 1 mikrosec. casovac je inkrementovan 
;po 1 mikrosekunde
;Funguje jako semafor, cili cervena, chodci cervena
							;chodci zelena
							;chodci cervena
							;cervena + zluta
							;zelena
							;zluta
							;cervena
;po stisku tlacitka prechazet se rozsviti kontrolka cekejte - nast v INT a nastavi se priznak
;az se dojde k zelene pro auta je podstatne zkracen interval zelene
;zaroven jsou nulovany promenne casu pro 10 sec, protoze pokud jiz jsem ve smycce 10sec, nestalo by se nic
;pro prechod do blikani je po stisku tlacitka a jeho uvolneni zhasne vse, rozsviti se zluta, je invertovan flag
;tento flag je cten po kazde smycce, je-li nastaven nasleduje blikani, je-li nulovan, nasleduje skok na zacatek


       LIST P=16F628A, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628A.INC"  ; Include header file 

        __config  _INTRC_OSC_NOCLKOUT &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BOREN_OFF & _CP_OFF & _DATA_CP_OFF & _MCLRE_OFF

  		

TMP0	equ	20H	;promenna pro ulozeni nizsiho byte timeru
TMP1	equ	21H	;promenna pro ulozeni vyssiho byte timeru
TMPW	equ	22H	;docasna promenna pro ulozeni W v int.
TMPS	equ	23H	;totez jako vyse pro ulozeni status
TMP2	equ	24H	;registr pro flagy
flag	equ	25H
TMP3	equ	26H	;pro cekani 10 sec jsou promenne oddelene
TMP4	equ	27H
TMP5	equ	28H



blik	equ	01H	;flag pro prechod do blikaciho rezimu
prechazet	equ 02H	;flag pro prechazeni

;----------------OBSAZENI PORTU-----------------------------------
#define	ruda_auto	PORTA,1	;vyvod 18
#define	zluta_auto	PORTA,0	;vyvod 17
#define	zelena_auto	PORTB,4	;vyvod 10
#define	ruda_chodci		PORTB,7	;vyvod 13
#define	zelena_chodci	PORTA,7	;vyvod 16
#define	cekejte			PORTA,6	;vyvod 15

#define	tlac_chodci		PORTB,6	;vyvod 12
#define	tlac_blikej		PORTB,0	;vyvod 6

 ORG    0x000            ; Program starts at 0x000 
	goto init
	ORG 4			;preruseni
	goto int1


int1
;-------------uloz data-----------------
	movwf	TMPW		; ulozi W
	swapf	STATUS,W	; prohodi nibble STATUS a ulozi do W
	bcf	STATUS,RP0	; nastaveni banky 0
	movwf	TMPS		; ulozit STATUS
;---------------------------------------
	btfss	INTCON,INTF ;prislo preruseni od zmeny na portu B, shod flag
 	goto	prechazeni	;pozadavek prechazeni
 
 	btfss	flag,blik
	goto	pokr_02
	bcf		flag,blik
 	goto	pokr_03
pokr_02
	bsf		flag,blik
pokr_03
 	bcf	ruda_chodci		;chodci cervena, auto cervena
	bcf	ruda_auto
	bsf	zluta_auto
	bcf	zelena_auto
	bcf	zelena_chodci	
	bcf	cekejte
  ;Variables: TMP2, TMP1, TMP0
;Delay 500000 cycles
        MOVLW 0x7F  ;127 DEC
        MOVWF TMP5
        MOVLW 0x0CF  ;207 DEC
        MOVWF TMP4
        MOVLW 0x05  ;5 DEC
        MOVWF TMP3
        DECFSZ TMP3,F
        GOTO $-1
        DECFSZ TMP4,F
        GOTO $-5
        DECFSZ TMP5,F
        GOTO $-9
;End of Delay
   	bcf		INTCON,INTF
  	goto IntRet
 
prechazeni
 	bcf		INTCON,RBIF ;prislo preruseni od zmeny na portu B, shod flag
	movf	PORTB,W		;musi se cist
	btfsc	flag,blik		;pokud jsem v blikani, nereaguj na stisk prechazet
	goto	IntRet
 	bsf		cekejte
 	bsf		flag,prechazet
  	goto	IntRet
  
 
 
;----------natahni data zpet-----------------------
        
IntRet swapf TMPS,W ; pvodn registr STATUS do W 
  movwf STATUS ; navrcen registru STATUS 
  swapf TMPW,F ; prprava pvodnho registru W 
  swapf TMPW,W ; nvrat pvodnho registru W 
  retfie 



; --------------------------------
; SET ANALOG/DIGITAL INPUTS PORT A
; --------------------------------
;
init	movlw 7
	movwf CMCON		; CMCON=7 set comparators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
	bcf STATUS,RP0		;banka 0
	movlw b'00000000'   ;set up portA
	movwf PORTA	
        
	movlw b'01000001'	; 
    movwf PORTB

        bsf STATUS,RP0          ; RAM PAGE 1
		bcf OPTION_REG, 7		; enable internal pullups

;----------PORT A-----------------------
        movlw b'00000000'
        movwf TRISA		; portA

;----------PORT B-----------------------
       movlw b'01000001'	;  input 
       movwf TRISB

		bcf	STATUS,RP0
		bcf	STATUS,IRP	;
;-----------INTERRUPT------------------
 	bcf	INTCON,RBIF ;prislo preruseni od zmeny na portu B, shod flag
	bcf	INTCON,INTF
	
	bsf INTCON, INTE ; Enable Peripheral Interrupt RB0
	bsf	INTCON,	RBIE	;povol INT zmenou na portu B
	bsf INTCON, PEIE ; Enable all unmasked Peripheral Interrupts
	bsf INTCON, GIE ; Enable all Interrupts

start
	bcf	cekejte
	bcf	flag,blik
	bcf	flag,prechazet
	
zacatek
	bsf	ruda_chodci		;chodci cervena, auto cervena
	bsf	ruda_auto
	bcf	zluta_auto
	bcf	zelena_auto
	bcf	zelena_chodci

;---------------------------		
	call	dve_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------	
	bcf	ruda_chodci		;chodci zelena
	bcf	cekejte
	bsf	zelena_chodci
	bcf	flag,prechazet
;---------------------------	
	call	pet_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------	
	bcf	zelena_chodci	;chodci cervena
	bsf	ruda_chodci
;---------------------------	
	call	dve_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------	
	bsf	zluta_auto		;sviti cervena a zluta
;---------------------------	
	call	dve_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------	
	bcf	ruda_auto		;cervena zluta zhasnout, zelena auta zapnout
	bcf	zluta_auto
	bsf	zelena_auto
	call	deset_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------
	bcf	zelena_auto		;zelena zhasnout, rozsvitit zluta
	bsf	zluta_auto
;---------------------------	
	call	dve_sec
	btfsc	flag,blik	;pokud je nahozen, sup na blikani
	goto	blik_zluta
;---------------------------	
	bcf	zluta_auto
	goto	zacatek



;Variables: TMP2, TMP1, TMP0
;Delay 1000000 cycles
jedna_sec   
	btfsc	flag,blik	;otestuj pozadavek blikani zlutou, pokud je nastaven
        return			;necasuj a navrat
no_test
		MOVLW 0x15  ;21 DEC
        MOVWF TMP2
        MOVLW 0x59  ;89 DEC
        MOVWF TMP1
        MOVLW 0x0B1  ;177 DEC
        MOVWF TMP0
        DECFSZ TMP0,F
        GOTO $-1
        DECFSZ TMP1,F
        GOTO $-5
        DECFSZ TMP2,F
        GOTO $-9
		return

;Variables: TMP2, TMP1, TMP0
;Delay 2000000 cycles
dve_sec   	call	jedna_sec 
		call	jedna_sec 
		return
	
 ;Variables: TMP2, TMP1, TMP0
;Delay 4999996 cycles
pet_sec  call	jedna_sec 
		call	jedna_sec 
		call	jedna_sec 
		call	jedna_sec 
		call	jedna_sec 
		return

;Variables: TMP2, TMP1, TMP0
;Delay 10000000 cycles
;testuje se flag pro prechazeni, protoze pokud je stisknuto tlacitko behem casovani
;nedoslo by ke zkraceni
deset_sec 
		call	jedna_sec 
	 	btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
		call	jedna_sec 
		btfsc	flag,prechazet
        goto	pokr_05
pokr_05	call	jedna_sec 
		call	jedna_sec 
        return


blik_zluta
	call	no_test
	btfss	zluta_auto
	goto	neg_zluta_auto
	bcf		zluta_auto
	goto	pokr_01
neg_zluta_auto
	bsf		zluta_auto
pokr_01
	btfsc	flag,blik	;pokud je shozen, sup na zacatek
	goto	blik_zluta
	goto	start

  
        END
